clear all;
clc;
Ang_p=zeros(500,1);
Vol_p=zeros(500,1);
time=zeros(500,1);
j=1;
k=1;
[file,path] = uigetfile ('*');    %%%% MatLAB gets the file

R=readtable (file);                   %%%% Reads the table present in the file
C=table2cell(R);                      %%%% Table is converted to cells
A= cell2mat(C);                        %% Cells are converted to a matrix


T = A(:,1);               %% variables and their respective columns  
Ang = A(:,2);
Vol = A(:,3);
Vel = A(:,4);
Acc = A (:,5);
thresh=0;
phi = cumtrapz(Vol);        %%% Calculates the cumulative trapezoidal integral of Voltage

[pks1, locs1] = findpeaks(Ang,'MinPeakHeight',thresh);%%% Finds the positive peaks of Ang and Location

%Ang_p=pks1 ;
 for i=1:size(pks1,1)
    Ang_p(i)=pks1(j);
    PT(i)=locs1(j);
    j=j+1;
 end
 for m=1:size(PT,2)
     time(m)=T(PT(m));
 end

 [pks2, locs2] = findpeaks(Ang);  %%% Finds the negative peaks of Ang and Location
  Ang_n = pks2(pks2<0);
 [pks3, locs3] = findpeaks(Vol,'MinPeakHeight',thresh);    %% Finds Positive Peaks of Vol and Location
%   Vol_p=pks3(pks3>0);
  for i=1:size(pks3,1)
    Vol_p(i)=pks3(k);
    k=k+1;
end
 [pks4, locs4] = findpeaks(-Vol);   %%% Finds Negative Peaks of Vol and Location
 Vol_n = pks4(pks4<0);

 if locs1(1)<locs2(1)
    a=1;
AngLeng = length(Ang);
Ang_nLeng = length(Ang_n);
AngDiff = AngLeng-Ang_nLeng;
if AngDiff > 0
    for b=1:length(Ang_n)
    MeanAng(a) = Ang(b) + Ang_n(b)/2;   %Mean of Ang
    AngTime(a) = locs1(b) + locs2(b)/2; %% Mean of Time
    a=a+1;
    end
elseif AngDiff < 0
    for b=1:length(Ang)
    MeanAng(a) = Ang(b) + Ang_n(b)/2;
    AngTime(a) = locs1(b) + locs2(b)/2;
    a=a+1;
    end
else
    for b=1:length(Ang)                         %%% Ang = Positive Values of Ang
    MeanAng(a) = Ang(b) + Ang_n(b)/2;           %% Ang_n = neagtive values of Ang
    AngTime(a) = locs1(b) + locs2(b)/2;
    a=a+1;
    end
end
elseif locs1(1)>locs2(1)
    a=1;
AngLeng = length(Ang);
Ang_nLeng = length(Ang_n);
AngDiff = AngLeng-Ang_nLeng;
if AngDiff > 0
    for b=1:length(Ang_n)-1
    MeanAng(a) = Ang(b) + Ang_n(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
    end
elseif AngDiff < 0
    for b=1:length(Ang)
    MeanAng(a) = Ang(b) + Ang_n(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
    end
else
    for b=1:length(Ang_n)-1
    MeanAng(a) = Ang(b) + Ang_n(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
    end
end
 end
if locs3(1)<locs4(1)
    n=1;
VolLeng = length(Vol);          %%% Vol = Positive Values of Vol
Vol_nLeng = length(Vol_n);
VolDiff = VolLeng-Vol_nLeng;    %%% Vol_n = Negative Values of Vol
if VolDiff > 0
    for i=1:2:length(Vol_n)-1
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i) + Vol_n(i+1))/4;   %% Mean of Vol
  n=n+1;
    end
elseif VolDiff < 0
    for i=1:2:length(Vol)-1
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i) + Vol_n(i+1))/4;
  n=n+1;
    end
else
    for i=1:2:length(Vol)-1
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i) + Vol_n(i+1))/4;
  n=n+1;
    end
end
elseif locs3(1)>locs4(1)
    n=1;
VolLeng = length(Vol);
Vol_nLeng = length(Vol_n);
VolDiff = VolLeng-Vol_nLeng;
if VolDiff > 0
    for i=1:2:length(Vol_n)-2
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i+1) + Vol_n(i+2))/4;
  n=n+1;
    end
elseif VolDiff < 0
    for i=1:2:length(Vol)-1
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i+1) + Vol_n(i+2))/4;
  n=n+1;
    end
else
    for i=1:2:length(Vol_n)-2
  MeanVol(n) = (Vol(i) + Vol(i+1) + Vol_n(i+1) + Vol_n(i+2))/4;
  n=n+1;
    end
end
end
 

Ang_p=sort(Ang_p,'descend'); %%%Sort the values of positive peak angle in decending order
Vol_p=sort(Vol_p, 'descend'); %%%Sort the values of positive peak voltage in decending order
      
figure                      %%% Plotting the data
hold on
grid on


subplot(4,2,1);         %%% Plots All Graphs in Position 1

plot (T, phi, 'r', T, Ang, 'b', T, Vol, 'black', T, Vel, 'cyan', T, Acc, 'magenta');
title ('All Quantities Against Time');
xlabel('Time (s)')
ylabel('Magnitude')

subplot (4,2,2)         %%% plots Ang VS Time in Position 2

plot (T,Ang,'.-');
title ('Angle VS Time Curve');
xlabel('Time (s)')
ylabel('Angle (rads)')

subplot (4,2,3)         %%%% Plots Vol VS Time in Position 3
plot (T, Vol, '.-')
title ('Voltage VS Time');
xlabel('Time')
ylabel('Voltage')

subplot (4,2,4)         %%% Plots Vel against Time in Position 4
plot (T, Vel, '.-')
title('Angular Velocity VS Time Curve');
xlabel('Time(s)');
ylabel('Angular Velocity (rad/s)');

subplot (4,2,5)         %%%% Plots Acc against Time in Position 5
plot(T, Acc, '.-')
title('Angular Acceleration VS Time Curve')
xlabel('Time(s)');
ylabel('Angular Acceleration (rad/s^2)');

subplot (4,2,6)         %%% Plots phi VS time in Position 6
plot (T,phi, '.-')
title ('Flux VS Time Curve')
xlabel('Time (s)');
ylabel ('Flux (phi)');


subplot (4,2,7)         %%% Plots Max Ang VS Time in position 7
plot(time,Ang_p, '.-')
title('Maximum Values of Angle VS Time Plot')
xlabel('Time (s)')
ylabel('Maximum Values of Angle (rad)')
subplot (4,2,8)
plot(Ang_p,Vol_p, '.-')
title('Maximum Voltage VS Maximum Angle Curve') %%% Plots Max Vol against Max Ang in Position 8
xlabel('Maximum Angle(rad)')
ylabel('Maximum Voltage (mV)')